栏目分类:
子分类:
返回
名师互学网用户登录
快速导航关闭
当前搜索
当前分类
子分类
实用工具
热门搜索
名师互学网 > IT > 软件开发 > 后端开发 > C/C++/C#

动态规划(dp)题目练习

C/C++/C# 更新时间: 发布时间: IT归档 最新发布 模块sitemap 名妆网 法律咨询 聚返吧 英语巴士网 伯小乐 网商动力

动态规划(dp)题目练习

1.最大子数组和

题目链接:https://leetcode.cn/problems/maximum-subarray/
题目描述:

解题思路:

dp[i] 定义为 以nums[i]结尾的最大字段和 。 如果dp[i-1]<0,那么dp[i]肯定是单独成段,所以dp[i]就等于nums[i],相反当dp[i-1]>0,那么nums[i]+dp[i-1]肯定是大于nums[i]单独成段的。

代码如下:
class Solution {
public:
    int maxSubArray(vector& nums) {
        int dp[100005]={0};
        dp[0]=nums[0];
        for(int i=1;i
            if(dp[i-1]<0){
                dp[i]=nums[i];
            }else{
                dp[i]+=nums[i]+dp[i-1];
            }
        }
        int maxn=dp[0];
        for(int i=0;i
            //cout<maxn){
                maxn=dp[i];
            }
        }
        return maxn;
    }
};
2.最长递增子序列

题目链接:https://leetcode.cn/problems/longest-increasing-subsequence/
题目描述:

解题思路:

代码如下:
class Solution {
public:
    int lengthOfLIS(vector& nums) {
        int i,j,dp[2505];
        fill(dp,dp+2505,1);//初始化 数组为1
        for(i=1;i
            for(j=i-1;j>=0;j--){
                if(nums[j]
                    dp[i]=max(dp[j]+1,dp[i]);
                }
            }
        }
        int maxn=dp[0];
        for(i=0;i
            //cout<maxn){
                maxn=dp[i];
            }
        }
        return maxn;
    }
};
3.最小路径和

题目链接:https://leetcode.cn/problems/minimum-path-sum/
题目描述:

解题思路:

观察示例可知,右下角的位置能从他上面或者左边到达,我们只需要保证左边和上面是最优,就能得到终点是最优的。
dp[i][i]定义为到达i,j的最少和。需要特殊处理的是边界条件,第一行和第一列都要特殊处理。
所以状态转移为 dp[i][j] = min( dp[i-1][j] , dp[i][j-1] ) + grid[i][j];

代码如下:
class Solution {
public:
    int minPathSum(vector>& grid) {
        int dp[205][205];
        int i,j;
        for(i=0;i
            for(j=0;j
                if(i==0&&j==0){
                    dp[0][0]=grid[0][0];
                }else if(i-1<0){//特殊处理第一行
                    dp[i][j]=dp[i][j-1]+grid[i][j];
                }else if(j-1<0){//特殊处理第一列
                    dp[i][j]=dp[i-1][j]+grid[i][j];
                }else
                dp[i][j]=min(dp[i-1][j],dp[i][j-1])+grid[i][j];
            }
        }
        return dp[i-1][j-1];
    }
};
4.不同路径 2

题目链接:https://leetcode.cn/problems/unique-paths-ii/
题目描述:

解题思路:

观察示例可以看出,因为机器人只能向右或者向下移动,所以到达终点的方案数等于它上面的位置方案数加左边的位置方案数。
dp[i][j]定义为到达[i][j]的最大方案数。边界特殊处理,第一行上面没有,第一列左边没有。
那么状态转移为 dp[i][j]=dp[i-1][j]+dp[i][j-1];

class Solution {
public:
    int uniquePathsWithObstacles(vector>& obstacleGrid) {
        int dp[205][205];
        int i,j;
        for(i=0;i
            for(j=0;j
                if(obstacleGrid[i][j]) {
                    dp[i][j]=0;//障碍走不了为0
                }else if(i==0&&j==0){
                    dp[0][0]=1;
                }else if(i-1<0){
                    dp[i][j]=dp[i][j-1];
                }else if(j-1<0){
                    dp[i][j]=dp[i-1][j];
                }else
                dp[i][j]=dp[i-1][j]+dp[i][j-1];
            }
        }
        return dp[i-1][j-1];
    }
};
转载请注明:文章转载自 www.mshxw.com
本文地址:https://www.mshxw.com/it/928113.html
我们一直用心在做
关于我们 文章归档 网站地图 联系我们

版权所有 (c)2021-2022 MSHXW.COM

ICP备案号:晋ICP备2021003244-6号